package pluck;

import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;


public class CallDB {
	public class CallInfo{
		public long refId=0;
		public Date updateTime=null;
		public int locIn;
		public int locOut;
		public CallInfo(int loc, Date currentTime) {
			this.locIn=loc;
			this.updateTime=currentTime;
		}
	}

private Map<Long,CallInfo> calls;
private HashMap<Long,Long> refCalls;
	public CallDB(){
		calls=Collections.synchronizedMap(new HashMap<Long,CallInfo>());
		refCalls=new HashMap<Long,Long>();
			}
	public boolean update(long id,long rid,int loc){
		if(id==0) return false;
		synchronized (calls) {
			CallInfo ci;
			if(rid!=0){
				ci=calls.get(rid);
				if(null!=ci){
					ci.refId=id;
					refCalls.put(id, rid);
				}else{
					ci=calls.get(id);
				}
			}else{
				Long cr=refCalls.get(id);
				if(cr!=null) ci=calls.get(cr);
				else ci=calls.get(id);
			}
			if(ci!=null){
				ci.locOut=loc;
				ci.updateTime=getCurrentTime();
				
			} else  {
				calls.put(id,new CallInfo(loc,getCurrentTime()));
			}
		}
		return true;
	}
	public boolean delete(long id){
		CallInfo ci=calls.get(id);
		if(ci==null) return false;
		refCalls.remove(ci.refId);
		calls.remove(id);
		return true;
	}
	private  Date getCurrentTime() {
		Calendar c=Calendar.getInstance();
		return c.getTime();
	}
	public int getLocation(long id) {
		CallInfo ci=calls.get(id);
		if(ci==null) return 0;
		return ci.locIn;
	}
	public int getCallsNum() {
		return calls.size();
	}
	public int getRefsNum() {
		return refCalls.size();
	}
}
