package pluck;


import java.io.FileInputStream;
import java.io.IOException;
import java.net.SocketException;
import java.util.HashMap;
import java.util.Properties;


import m200.M200Iface;
import m200.exceptions.M200MsgClassNotEqMsgTypeException;
import m200.messages.M200Msg;
import m200.messages.M200MsgCall;
import m200.messages.M200MsgRelease;
import m200.messages.M200MsgSeizure;
import m200.messages.detail.M200MsgReleaseIn;
import m200.messages.detail.M200MsgReleaseOut;


public class Main implements M200Iface.M200MsgReceiver {
	SNMPAgent snmp;
	M200Iface mi;
	private HashMap<Integer, pluck.M200MsgHdlr> map;
	private CallDB currDB;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Main main=new Main();
		M200Iface mi=new M200Iface(args[0],Integer.parseInt(args[1]),main);
		main.process(mi);
	}

	public Main(){
		currDB=new CallDB();
		Properties snmpProps = new Properties();
		try {
			FileInputStream in = new FileInputStream("snmp.prop");
			snmpProps.load(in);
			in.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

		try {
			snmp=new SNMPAgent(20031,"public",snmpProps);
		} catch (SocketException e1) {
			e1.printStackTrace();
		}
	}
	private void process(M200Iface mi) {
		this.mi=mi;
		map=new HashMap<Integer,M200MsgHdlr>();
		map.put(M200MsgSeizure.getType(),new M200MsgHdlr(){
			public boolean process(M200Msg msg, CallDB db) {
				try {
					M200MsgSeizure msgSeiz = M200MsgSeizure.cast(msg);
					return db.update(msg.getCallId(),0,msgSeiz.getLocation());
				} catch (M200MsgClassNotEqMsgTypeException e) {
					e.printStackTrace();
				}
				return false;
			}
			
		});
		map.put(M200MsgCall.getType(),new M200MsgHdlr(){
			public boolean process(M200Msg msg, CallDB db) {
				try {
					M200MsgCall msgCall = M200MsgCall.cast(msg);
					return db.update(msg.getCallId(),msgCall.getRefId(),msgCall.getLocation());
				} catch (M200MsgClassNotEqMsgTypeException e) {
					e.printStackTrace();
				}
				return false;
			}
			
		});
		map.put(M200MsgReleaseIn.getType(),new M200MsgHdlr(){
			public boolean process(M200Msg msg, CallDB db) {
				try {
					M200MsgRelease msgRel = M200MsgRelease.cast(msg);
					snmp.incReleaseCauseCount(msgRel.getCause());
					snmp.incReleaseCauseCount(msgRel.getCause(),db.getLocation(msg.getCallId()));
					return db.delete(msg.getCallId());
				} catch (M200MsgClassNotEqMsgTypeException e) {
					e.printStackTrace();
				}
				return false;
			}
		});
		map.put(M200MsgReleaseOut.getType(),new M200MsgHdlr(){
			public boolean process(M200Msg msg, CallDB db) {
				try {
					M200MsgRelease msgRel = M200MsgRelease.cast(msg);
					snmp.incReleaseCauseCount(msgRel.getCause(),db.getLocation(msg.getCallId()));
					return db.delete(msg.getCallId());
				} catch (M200MsgClassNotEqMsgTypeException e) {
					e.printStackTrace();
				}
				return false;
			}
		});
		mi.process();
		try {
			while(true) Thread.sleep(99999);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.exit(0);
	}


	@Override
	public void NewM200Message(M200Msg msg) {
		M200MsgHdlr h=map.get(msg.getBodyType());
		if(h!=null) if(h.process(msg,currDB)) snmp.setCheckups(currDB.getCallsNum(), currDB.getRefsNum());
	}
}
